#!/usr/local/bin/perl
#^^^^^^^^^^^^^^^^^^^^ Update this to the path of Perl on your system
$GETTEMP_ROOT = "/home/swatch/gettemp";
#^^^^^^^^^^^^^^^^^^^^ Update this also

#-------------- Should be fairly boilerplate from here on out --------------
# gettemp.cgi - display the hostorical temp data ...
# Copyright 1999, 2000  by Alek Komarnitsky, alek@komar.org, http://www.komar.org/komar/alek/
# See LICENSE for conditions of use.

require "$GETTEMP_ROOT/gettemp.all.ph";
$| = 1;   # Web Servers seem to like this better ...
&ReadParse;
$filename = $in{'filename'};
$num_lines_temp_data = 0;
print "Content-type: text/html\n\n\n" ;      
print "<html><pre>";
print "          <b><u>Temperature data from $filename</b></u>\n\n";
if ( -r "$filename" ) {
   open (STUFF,"<$filename") ||  ( print "Can't open $filename: $!" || die() ) ;
   while (<STUFF>) {
      $line = $_;
      if ( (/^$/) || (/^\s+$/) || ( /not pingable/ ) || ( /timed out/ ) || ( /can not rsh/ ) || ( /no temp data available/ ) || ( /Temperature Data for/) ) {
         # ignore these lines ...
      } else {
         $num_lines_temp_data++;
         (@temp_array) = split();
         foreach $i (0 .. $#temp_array) {
            next if ($i < 4 ) ;
            if ( (int( $i /3 )) eq ($i/3)) {            
               $_ = $temp_array[$i];
               if (/\d+/) {
                  if ( $in{'temp'} eq "f" ) {
                     $_ = (9 * $_ / 5 ) + 32;
                  }
                  $temp_ave{$temp_array[$i-2]} = $temp_ave{$temp_array[$i-2]} + $_ ;
                  if ( $_ > $temp_high{$temp_array[$i-2]} ) {
                     $temp_high{$temp_array[$i-2]} = $_ ;
                  }
               }
            }
         }
      }
      if ( $in{'temp'} eq "f" ) {
         $line =~ s/ \d+ /sprintf(" %3d ", ($&*9\/5+32))/eg;
         $line =~ s/ \d+$/sprintf(" %3d", ($&*9\/5+32))/eg;
         $line =~ s/in Celsius/in Fahrenheit/;
      }
      $line =~ s/ WARM /\<font color=\"orange\"\> WARM \<\/font\>/g;
      $line =~ s/ HOT! /\<font color=\"red\"\> HOT! \<\/font\>/g;
      print $line;
   }
   close (STUFF);
   print "\n";
   foreach $temp_value (sort keys %temp_high) {
      printf "%-10s%s%5.1f%s%5.1f" , "$temp_value:", "highest temp was " , $temp_high{$temp_value} , " and the average was " , $temp_ave{$temp_value}/$num_lines_temp_data;
      if ( $in{'temp'} eq "f" ) {
         print " Fahrenheit\n";
      } else {
         print " Celsius\n";
      }
   }
   if ( $in{'temp'} eq "f" ) {
      print "<font color=\"orange\">WARM:</font>     AMBIENT > " , ((9 * $ambient_warm/5) + 32) , " or CPU > " , ((9 * $cpu_warm/5) + 32) , " \&deg;Fahrenheit ... or \"not OK\" as reported by some systems\n<br>";
      print "<font color=\"red\">HOT!:</font>     AMBIENT > " , ((9 * $ambient_hot/5) + 32) , " or CPU > " , ((9 * $cpu_hot/5) + 32) , " \&deg;Fahrenheit ... or \"not OK\" as reported by some systems\n<br>";
   } else {
      print "<font color=\"orange\">WARM:</font>     AMBIENT > $ambient_warm or CPU > $cpu_warm \&deg;Celsius ... or \"not OK\" as reported by some systems\n<br>";
      print "<font color=\"red\">HOT!:</font>     AMBIENT > $ambient_hot or CPU > $cpu_hot \&deg;Celsius ... or \"not OK\" as reported by some systems\n<br>";
   }
irected
} else {
   print "Could not read $filename \n";
}
$filename =~ s/\d\d$//;
$filename =~ s/\/home\/swatch//;
print "\n<a href=\"$filename\">Quick-n-dirty hack job to see ALL data files for this machine</a><p>";
print "\nYes, we could do more (ala MRTG which is good stuff)\nbut I am a fan of KISS so we will stick with this for now.\n";
print "\nSend comments on gettemp-$version to <a href=\"mailto:$email_address\">$email_address</a>\n";
print "</html>";
exit(); 


# HTML parsing ...
sub ReadParse {
   if (@_) { local (*in) = @_; }
   local ($i, $loc, $key, $val);
   # Read in text
   if ($ENV{'REQUEST_METHOD'} eq "GET") {
      $in = $ENV{'QUERY_STRING'};
   } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
         $in .= getc;  }
   }
   @in = split(/&/,$in);
   foreach $i (0 .. $#in) {
      # Convert plus's to spaces
      $_ = $in[$i];
      $in[$i] = &sanitize($_);
      $in[$i] =~ s/\+/ /g;
      # Convert %XX from hex numbers to alphanumeric
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
      # Split into key and value.
      $loc = index($in[$i],"=");
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
  }
}


# Added per CERT advistory - send Alek EMail if you want changes here ...
sub sanitize {
   local ($OK_CHARS);
   $OK_CHARS='-a-zA-Z0-9_?=/!';
   s/[^$OK_CHARS]/_/go;
   return $_;
}
